// 
// File:          gov_cca_ComponentID.hh
// Symbol:        gov.cca.ComponentID-v0.6.3
// Symbol Type:   interface
// Babel Version: 0.10.2
// Description:   Client-side glue code for gov.cca.ComponentID
// 
// WARNING: Automatically generated; changes will be lost
// 
// babel-version = 0.10.2
// 

#ifndef included_gov_cca_ComponentID_hh
#define included_gov_cca_ComponentID_hh

// declare class before #includes
// (this alleviates circular #include guard problems)[BUG#393]
namespace gov { 
  namespace cca { 

    class ComponentID;
  } // end namespace cca
} // end namespace gov

// Some compilers need to define array template before the specializations
#ifndef included_sidl_cxx_hh
#include "sidl_cxx.hh"
#endif
namespace sidl {
  template<>
  class array< ::gov::cca::ComponentID >;
}

#ifndef included_sidl_cxx_hh
#include "sidl_cxx.hh"
#endif
#ifndef included_gov_cca_ComponentID_IOR_h
#include "gov_cca_ComponentID_IOR.h"
#endif
// 
// Includes for all method dependencies.
// 
#ifndef included_gov_cca_CCAException_hh
#include "gov_cca_CCAException.hh"
#endif
#ifndef included_sidl_BaseInterface_hh
#include "sidl_BaseInterface.hh"
#endif
#ifndef included_sidl_ClassInfo_hh
#include "sidl_ClassInfo.hh"
#endif

namespace gov { 
  namespace cca { 

    /**
     * Symbol "gov.cca.ComponentID" (version 0.6.3)
     * 
     * An opaque reference to a Component.
     */
    class ComponentID : public ::sidl::StubBase {

      //////////////////////////////////////////////////
      // 
      // User Defined Methods
      // 

    public:

      /**
       * <p>
       * Add one to the intrinsic reference count in the underlying object.
       * Object in <code>sidl</code> have an intrinsic reference count.
       * Objects continue to exist as long as the reference count is
       * positive. Clients should call this method whenever they
       * create another ongoing reference to an object or interface.
       * </p>
       * <p>
       * This does not have a return value because there is no language
       * independent type that can refer to an interface or a
       * class.
       * </p>
       */
      inline void
      addRef() throw () 
      {

        if ( !d_weak_reference ) {
          /*pack args to dispatch to ior*/
          (*(d_self->d_epv->f_addRef))(d_self->d_object );
          /*dispatch to ior*/
          /*unpack results and cleanup*/
        }
      }



      /**
       * Decrease by one the intrinsic reference count in the underlying
       * object, and delete the object if the reference is non-positive.
       * Objects in <code>sidl</code> have an intrinsic reference count.
       * Clients should call this method whenever they remove a
       * reference to an object or interface.
       */
      inline void
      deleteRef() throw () 
      {

        if ( !d_weak_reference ) {
          /*pack args to dispatch to ior*/
          (*(d_self->d_epv->f_deleteRef))(d_self->d_object );
          /*dispatch to ior*/
          /*unpack results and cleanup*/
          d_self = 0;
        }
      }



      /**
       * Return true if and only if <code>obj</code> refers to the same
       * object as this object.
       */
      bool
      isSame (
        /* in */ ::sidl::BaseInterface iobj
      )
      throw () 
      ;



      /**
       * Check whether the object can support the specified interface or
       * class.  If the <code>sidl</code> type name in <code>name</code>
       * is supported, then a reference to that object is returned with the
       * reference count incremented.  The callee will be responsible for
       * calling <code>deleteRef</code> on the returned object.  If
       * the specified type is not supported, then a null reference is
       * returned.
       */
      ::sidl::BaseInterface
      queryInt (
        /* in */ const ::std::string& name
      )
      throw () 
      ;



      /**
       * Return whether this object is an instance of the specified type.
       * The string name must be the <code>sidl</code> type name.  This
       * routine will return <code>true</code> if and only if a cast to
       * the string type name would succeed.
       */
      bool
      isType (
        /* in */ const ::std::string& name
      )
      throw () 
      ;



      /**
       * Return the meta-data about the class implementing this interface.
       */
      ::sidl::ClassInfo
      getClassInfo() throw () 
      ;


      /**
       * Returns the instance name provided in 
       * <code>BuilderService.createInstance()</code>
       * or in 
       * <code>AbstractFramework.getServices()</code>.
       * @throws CCAException if <code>ComponentID</code> is invalid
       */
      ::std::string
      getInstanceName() throw ( 
        ::gov::cca::CCAException
      );


      /**
       * Returns a framework specific serialization of the ComponentID.
       * @throws CCAException if <code>ComponentID</code> is
       * invalid.
       */
      ::std::string
      getSerialization() throw ( 
        ::gov::cca::CCAException
      );


      //////////////////////////////////////////////////
      // 
      // End User Defined Methods
      // (everything else in this file is specific to
      //  Babel's C++ bindings)
      // 

    public:
      typedef struct gov_cca_ComponentID__object ior_t;
      typedef struct gov_cca_ComponentID__external ext_t;
      typedef struct gov_cca_ComponentID__sepv sepv_t;

      // default constructor
      ComponentID() : d_self(0), d_weak_reference(false) { }

      // default destructor
      virtual ~ComponentID ();

      // copy constructor
      ComponentID ( const ComponentID& original );

      // assignment operator
      ComponentID& operator= ( const ComponentID& rhs );

      // conversion from ior to C++ class
      ComponentID ( ComponentID::ior_t* ior );

      // Alternate constructor: does not call addRef()
      // (sets d_weak_reference=isWeak)
      // For internal use by Impls (fixes bug#275)
      ComponentID ( ComponentID::ior_t* ior, bool isWeak );

      // conversion from a StubBase
      ComponentID ( const ::sidl::StubBase& base );

      ior_t* _get_ior() { return d_self; }

      const ior_t* _get_ior() const { return d_self; }

      void _set_ior( ior_t* ptr ) { d_self = ptr; }

      bool _is_nil() const { return (d_self==0); }

      bool _not_nil() const { return (d_self!=0); }

      bool operator !() const { return (d_self==0); }

    protected:
      virtual void* _cast(const char* type) const;

    private:
      // Pointer to sidl's IOR type (one per instance)
      ior_t * d_self;

      // Weak references (used by Impl's only) don't add/deleteRef()
      bool d_weak_reference;

      // Pointer to external (DLL loadable) symbols (shared among instances)
      static const ext_t * s_ext;

    public:
      static const ext_t * _get_ext() throw ( ::sidl::NullIORException );

    }; // end class ComponentID
  } // end namespace cca
} // end namespace gov

namespace sidl {
  // traits specialization
  template<>
  struct array_traits< ::gov::cca::ComponentID > {
    typedef array< ::gov::cca::ComponentID > cxx_array_t;
    typedef ::gov::cca::ComponentID cxx_item_t;
    typedef struct gov_cca_ComponentID__array ior_array_t;
    typedef sidl_interface__array ior_array_internal_t;
    typedef struct gov_cca_ComponentID__object ior_item_t;
    typedef  cxx_item_t value_type;
    typedef  value_type reference;
    typedef  value_type* pointer;
    typedef  const value_type const_reference;
    typedef  const value_type* const_pointer;
    typedef  array_iter< array_traits< ::gov::cca::ComponentID > > iterator;
    typedef  const_array_iter< array_traits< ::gov::cca::ComponentID > > 
      const_iterator;
  };

  // array specialization
  template<>
  class array< ::gov::cca::ComponentID >: public interface_array< array_traits< 
    ::gov::cca::ComponentID > > {
  public:
    typedef interface_array< array_traits< ::gov::cca::ComponentID > > Base;
    typedef array_traits< ::gov::cca::ComponentID >::cxx_array_t          
      cxx_array_t;
    typedef array_traits< ::gov::cca::ComponentID >::cxx_item_t           
      cxx_item_t;
    typedef array_traits< ::gov::cca::ComponentID >::ior_array_t          
      ior_array_t;
    typedef array_traits< ::gov::cca::ComponentID >::ior_array_internal_t 
      ior_array_internal_t;
    typedef array_traits< ::gov::cca::ComponentID >::ior_item_t           
      ior_item_t;

    /**
     * conversion from ior to C++ class
     * (constructor/casting operator)
     */
    array( struct gov_cca_ComponentID__array* src = 0) : Base(src) {}

    /**
     * copy constructor
     */
    array( const array< ::gov::cca::ComponentID >&src) : Base(src) {}

    /**
     * assignment
     */
    array< ::gov::cca::ComponentID >&
    operator =( const array< ::gov::cca::ComponentID >&rhs ) { 
      if (d_array != rhs._get_baseior()) {
        if (d_array) deleteRef();
        d_array = const_cast<sidl__array *>(rhs._get_baseior());
        if (d_array) addRef();
      }
      return *this;
    }

  };
}

#endif
