// 
// File:          gov_cca_ports_ConnectionEvent.cc
// Symbol:        gov.cca.ports.ConnectionEvent-v0.6.3
// Symbol Type:   interface
// Babel Version: 0.10.2
// Description:   Client-side glue code for gov.cca.ports.ConnectionEvent
// 
// WARNING: Automatically generated; changes will be lost
// 
// babel-version = 0.10.2
// 

#ifndef included_gov_cca_ports_ConnectionEvent_hh
#include "gov_cca_ports_ConnectionEvent.hh"
#endif
#ifndef included_sidl_BaseInterface_hh
#include "sidl_BaseInterface.hh"
#endif
#ifndef included_sidl_BaseClass_hh
#include "sidl_BaseClass.hh"
#endif
#include "sidl_String.h"
#include "babel_config.h"
#ifdef SIDL_DYNAMIC_LIBRARY
#include <stdio.h>
#include <stdlib.h>
#include "sidl_Loader.hh"
#endif


//////////////////////////////////////////////////
// 
// User Defined Methods
// 


/**
 * Return true if and only if <code>obj</code> refers to the same
 * object as this object.
 */
bool
gov::cca::ports::ConnectionEvent::isSame( /* in */ ::sidl::BaseInterface iobj )
throw ()

{
  bool _result;
  sidl_bool _local_result;
  /*pack args to dispatch to ior*/
  _local_result = (*(d_self->d_epv->f_isSame))(d_self->d_object,
    /* in */ iobj._get_ior() );
  /*dispatch to ior*/
  _result = _local_result;
  /*unpack results and cleanup*/
  return _result;
}



/**
 * Check whether the object can support the specified interface or
 * class.  If the <code>sidl</code> type name in <code>name</code>
 * is supported, then a reference to that object is returned with the
 * reference count incremented.  The callee will be responsible for
 * calling <code>deleteRef</code> on the returned object.  If
 * the specified type is not supported, then a null reference is
 * returned.
 */
::sidl::BaseInterface
gov::cca::ports::ConnectionEvent::queryInt( /* in */ const ::std::string& name )
throw ()

{
  ::sidl::BaseInterface _result;
  /*pack args to dispatch to ior*/
  _result = ::sidl::BaseInterface( 
    (*(d_self->d_epv->f_queryInt))(d_self->d_object, /* in */ name.c_str() ),
    false);
  /*dispatch to ior*/
  /*unpack results and cleanup*/
  return _result;
}



/**
 * Return whether this object is an instance of the specified type.
 * The string name must be the <code>sidl</code> type name.  This
 * routine will return <code>true</code> if and only if a cast to
 * the string type name would succeed.
 */
bool
gov::cca::ports::ConnectionEvent::isType( /* in */ const ::std::string& name )
throw ()

{
  bool _result;
  sidl_bool _local_result;
  /*pack args to dispatch to ior*/
  _local_result = (*(d_self->d_epv->f_isType))(d_self->d_object,
    /* in */ name.c_str() );
  /*dispatch to ior*/
  _result = _local_result;
  /*unpack results and cleanup*/
  return _result;
}



/**
 * Return the meta-data about the class implementing this interface.
 */
::sidl::ClassInfo
gov::cca::ports::ConnectionEvent::getClassInfo(  )
throw ()

{
  ::sidl::ClassInfo _result;
  /*pack args to dispatch to ior*/
  _result = ::sidl::ClassInfo( 
    (*(d_self->d_epv->f_getClassInfo))(d_self->d_object ), false);
  /*dispatch to ior*/
  /*unpack results and cleanup*/
  return _result;
}



/**
 * <p>Returns the integer from those enumerated that describes the event.</p>
 * 
 * <p>
 * The semantics are noted before
 * each member of the enum/static constant. We can add in different
 * types of connect/disconnect as multiports and
 * explicit local/global/sync/async semantics are agreed to in the future.
 * At present we assume that:
 * <ul>
 * <li> All instances in a component cohort (often thought of as a single
 *   "parallel component") receive all the events
 *   and in the same order, but not necessarily globally synchronously.
 * 
 * <li> For disconnections, within a process the events are delivered first
 *   to the using component then (if necessary) to the providing
 *   component.
 * 
 * <li> For connections, within a process the events are delivered first
 *   to the providing component then (if necessary) to the using
 *   component.
 * </ul>
 * </p>
 * 
 * <p>
 * Clearly some of the assumptions above may not suit a component
 * instance in which multiple execution threads act on a
 * single instance of the <code>cca.Services</code> object (SMP). The Services
 * specification is ambiguous as to whether such a component is even
 * allowed.
 * </p>
 * <p>
 * When this is clarified, additional members of the enum may arise,
 * in which case the assumptions here apply only to
 * <code>ConnectPending</code>, <code>Connected</code>, <code>DisconnectPending</code>, 
 * <code>Disconnected</code> types.
 */
::gov::cca::ports::EventType
gov::cca::ports::ConnectionEvent::getEventType(  )
throw ()

{
  ::gov::cca::ports::EventType _result;
  enum gov_cca_ports_EventType__enum _local_result;
  /*pack args to dispatch to ior*/
  _local_result = (*(d_self->d_epv->f_getEventType))(d_self->d_object );
  /*dispatch to ior*/
  _result = (::gov::cca::ports::EventType)_local_result;
  /*unpack results and cleanup*/
  return _result;
}



/**
 * Get Properties of the affected Port.
 * Among the standard properties are the name and type info.
 */
::gov::cca::TypeMap
gov::cca::ports::ConnectionEvent::getPortInfo(  )
throw ()

{
  ::gov::cca::TypeMap _result;
  /*pack args to dispatch to ior*/
  _result = ::gov::cca::TypeMap( 
    (*(d_self->d_epv->f_getPortInfo))(d_self->d_object ), false);
  /*dispatch to ior*/
  /*unpack results and cleanup*/
  return _result;
}



//////////////////////////////////////////////////
// 
// End User Defined Methods
// (everything else in this file is specific to
//  Babel's C++ bindings)
// 

// default destructor
gov::cca::ports::ConnectionEvent::~ConnectionEvent () {
  if ( d_self != 0 ) {
    deleteRef();
  }
}

// copy constructor
gov::cca::ports::ConnectionEvent::ConnectionEvent ( const 
  ::gov::cca::ports::ConnectionEvent& original ) {
  d_self = const_cast< ior_t*>(original.d_self);
  d_weak_reference = original.d_weak_reference;
  if (d_self != 0 ) {
    addRef();
  }
}

// assignment operator
::gov::cca::ports::ConnectionEvent&
gov::cca::ports::ConnectionEvent::operator=( const 
  ::gov::cca::ports::ConnectionEvent& rhs ) {
  if ( d_self != rhs.d_self ) {
    if ( d_self != 0 ) {
      deleteRef();
    }
    d_self = const_cast< ior_t*>(rhs.d_self);
    d_weak_reference = rhs.d_weak_reference;
    if ( d_self != 0 ) {
      addRef();
    }
  }
  return *this;
}

// conversion from ior to C++ class
gov::cca::ports::ConnectionEvent::ConnectionEvent ( 
  ::gov::cca::ports::ConnectionEvent::ior_t* ior ) 
    : d_self( ior ), d_weak_reference(false) {
  if ( d_self != 0 ) {
    addRef();
  }
}

// Alternate constructor: does not call addRef()
// (sets d_weak_reference=isWeak)
// For internal use by Impls (fixes bug#275)
gov::cca::ports::ConnectionEvent::ConnectionEvent ( 
  ::gov::cca::ports::ConnectionEvent::ior_t* ior, bool isWeak ) 
    : d_self( ior ), d_weak_reference(isWeak) { 
}

// conversion from a StubBase
gov::cca::ports::ConnectionEvent::ConnectionEvent ( const ::sidl::StubBase& 
  base )
{
  d_self = reinterpret_cast< 
    ior_t*>(base._cast("gov.cca.ports.ConnectionEvent"));
  d_weak_reference = false;
  if (d_self != 0) {
    addRef();
  }
}

// protected method that implements casting
void* gov::cca::ports::ConnectionEvent::_cast(const char* type) const
{
  void* ptr = 0;
  if ( d_self != 0 ) {
    ptr = reinterpret_cast< void*>((*d_self->d_epv->f__cast)(d_self->d_object,
      type));
  }
  return ptr;
}

extern "C" {


} // end extern "C"
