// 
// File:          gov_cca_ports_ParameterGetListener.hh
// Symbol:        gov.cca.ports.ParameterGetListener-v0.6.3
// Symbol Type:   interface
// Babel Version: 0.10.2
// Description:   Client-side glue code for gov.cca.ports.ParameterGetListener
// 
// WARNING: Automatically generated; changes will be lost
// 
// babel-version = 0.10.2
// 

#ifndef included_gov_cca_ports_ParameterGetListener_hh
#define included_gov_cca_ports_ParameterGetListener_hh

// declare class before #includes
// (this alleviates circular #include guard problems)[BUG#393]
namespace gov { 
  namespace cca { 
    namespace ports { 

      class ParameterGetListener;
    } // end namespace ports
  } // end namespace cca
} // end namespace gov

// Some compilers need to define array template before the specializations
#ifndef included_sidl_cxx_hh
#include "sidl_cxx.hh"
#endif
namespace sidl {
  template<>
  class array< ::gov::cca::ports::ParameterGetListener >;
}

#ifndef included_sidl_cxx_hh
#include "sidl_cxx.hh"
#endif
#ifndef included_gov_cca_ports_ParameterGetListener_IOR_h
#include "gov_cca_ports_ParameterGetListener_IOR.h"
#endif
// 
// Includes for all method dependencies.
// 
#ifndef included_sidl_BaseInterface_hh
#include "sidl_BaseInterface.hh"
#endif
#ifndef included_sidl_ClassInfo_hh
#include "sidl_ClassInfo.hh"
#endif

namespace gov { 
  namespace cca { 
    namespace ports { 

      /**
       * Symbol "gov.cca.ports.ParameterGetListener" (version 0.6.3)
       * 
       * This interface is typically implemented by a 
       * component writer using the ParameterPortFactory
       * in a very dynamic fashion.
       *  
       *  The ParameterGet listeners are called when
       *  the readMap function is called on
       *  the ParameterPort interface. 
       *  The listener (usually the component owning the typemap) can change the 
       *  contents (title, groups, parameters) of the ParameterPort
       *  in their updateParameterPort function. These changed
       *  values will be returned to the caller (framework/gui).
       *  
       *  This is handy when the contents of one ParameterPort depend
       *  on values already set in another ParameterPort
       *  on the same component. E.g. selection of a particular chemical
       *  reaction mechanism in the first ParameterPort defines the
       *  set of chemical species that need initial-concentrations defined
       *  in the second ParameterPort.
       * 
       *  The fact that looking at a ParameterPort
       *  gives an opportunity for it to change will lead to Heisenbugs
       *  in the hands of an inept programmer.
       * 
       *  The name of the parameter port which is being used is passed
       *  so the component using the ParameterPortFactory to manage more 
       *  than one Parameter port can tell which one is being updated.
       * 
       *  The component should return TRUE if the contents of the
       *  parameter port were changed (cleared or added to) in the
       *  update function or if the component wants to receive all fresh input
       *  for current values.
       * 
       *  @see ParameterSetListener
       */
      class ParameterGetListener : public ::sidl::StubBase {

        //////////////////////////////////////////////////
        // 
        // User Defined Methods
        // 

      public:

        /**
         * <p>
         * Add one to the intrinsic reference count in the underlying object.
         * Object in <code>sidl</code> have an intrinsic reference count.
         * Objects continue to exist as long as the reference count is
         * positive. Clients should call this method whenever they
         * create another ongoing reference to an object or interface.
         * </p>
         * <p>
         * This does not have a return value because there is no language
         * independent type that can refer to an interface or a
         * class.
         * </p>
         */
        inline void
        addRef() throw () 
        {

          if ( !d_weak_reference ) {
            /*pack args to dispatch to ior*/
            (*(d_self->d_epv->f_addRef))(d_self->d_object );
            /*dispatch to ior*/
            /*unpack results and cleanup*/
          }
        }



        /**
         * Decrease by one the intrinsic reference count in the underlying
         * object, and delete the object if the reference is non-positive.
         * Objects in <code>sidl</code> have an intrinsic reference count.
         * Clients should call this method whenever they remove a
         * reference to an object or interface.
         */
        inline void
        deleteRef() throw () 
        {

          if ( !d_weak_reference ) {
            /*pack args to dispatch to ior*/
            (*(d_self->d_epv->f_deleteRef))(d_self->d_object );
            /*dispatch to ior*/
            /*unpack results and cleanup*/
            d_self = 0;
          }
        }



        /**
         * Return true if and only if <code>obj</code> refers to the same
         * object as this object.
         */
        bool
        isSame (
          /* in */ ::sidl::BaseInterface iobj
        )
        throw () 
        ;



        /**
         * Check whether the object can support the specified interface or
         * class.  If the <code>sidl</code> type name in <code>name</code>
         * is supported, then a reference to that object is returned with the
         * reference count incremented.  The callee will be responsible for
         * calling <code>deleteRef</code> on the returned object.  If
         * the specified type is not supported, then a null reference is
         * returned.
         */
        ::sidl::BaseInterface
        queryInt (
          /* in */ const ::std::string& name
        )
        throw () 
        ;



        /**
         * Return whether this object is an instance of the specified type.
         * The string name must be the <code>sidl</code> type name.  This
         * routine will return <code>true</code> if and only if a cast to
         * the string type name would succeed.
         */
        bool
        isType (
          /* in */ const ::std::string& name
        )
        throw () 
        ;



        /**
         * Return the meta-data about the class implementing this interface.
         */
        ::sidl::ClassInfo
        getClassInfo() throw () 
        ;


        /**
         * Inform the listener that someone is about to fetch their 
         * typemap. The return should be true if the listener
         * has changed the ParameterPort definitions.
         */
        bool
        updateParameterPort (
          /* in */ const ::std::string& portName
        )
        throw () 
        ;



        //////////////////////////////////////////////////
        // 
        // End User Defined Methods
        // (everything else in this file is specific to
        //  Babel's C++ bindings)
        // 

      public:
        typedef struct gov_cca_ports_ParameterGetListener__object ior_t;
        typedef struct gov_cca_ports_ParameterGetListener__external ext_t;
        typedef struct gov_cca_ports_ParameterGetListener__sepv sepv_t;

        // default constructor
        ParameterGetListener() : d_self(0), d_weak_reference(false) { }

        // default destructor
        virtual ~ParameterGetListener ();

        // copy constructor
        ParameterGetListener ( const ParameterGetListener& original );

        // assignment operator
        ParameterGetListener& operator= ( const ParameterGetListener& rhs );

        // conversion from ior to C++ class
        ParameterGetListener ( ParameterGetListener::ior_t* ior );

        // Alternate constructor: does not call addRef()
        // (sets d_weak_reference=isWeak)
        // For internal use by Impls (fixes bug#275)
        ParameterGetListener ( ParameterGetListener::ior_t* ior, bool isWeak );

        // conversion from a StubBase
        ParameterGetListener ( const ::sidl::StubBase& base );

        ior_t* _get_ior() { return d_self; }

        const ior_t* _get_ior() const { return d_self; }

        void _set_ior( ior_t* ptr ) { d_self = ptr; }

        bool _is_nil() const { return (d_self==0); }

        bool _not_nil() const { return (d_self!=0); }

        bool operator !() const { return (d_self==0); }

      protected:
        virtual void* _cast(const char* type) const;

      private:
        // Pointer to sidl's IOR type (one per instance)
        ior_t * d_self;

        // Weak references (used by Impl's only) don't add/deleteRef()
        bool d_weak_reference;

        // Pointer to external (DLL loadable) symbols (shared among instances)
        static const ext_t * s_ext;

      public:
        static const ext_t * _get_ext() throw ( ::sidl::NullIORException );

      }; // end class ParameterGetListener
    } // end namespace ports
  } // end namespace cca
} // end namespace gov

namespace sidl {
  // traits specialization
  template<>
  struct array_traits< ::gov::cca::ports::ParameterGetListener > {
    typedef array< ::gov::cca::ports::ParameterGetListener > cxx_array_t;
    typedef ::gov::cca::ports::ParameterGetListener cxx_item_t;
    typedef struct gov_cca_ports_ParameterGetListener__array ior_array_t;
    typedef sidl_interface__array ior_array_internal_t;
    typedef struct gov_cca_ports_ParameterGetListener__object ior_item_t;
    typedef  cxx_item_t value_type;
    typedef  value_type reference;
    typedef  value_type* pointer;
    typedef  const value_type const_reference;
    typedef  const value_type* const_pointer;
    typedef  array_iter< array_traits< ::gov::cca::ports::ParameterGetListener 
      > > iterator;
    typedef  const_array_iter< array_traits< 
      ::gov::cca::ports::ParameterGetListener > > const_iterator;
  };

  // array specialization
  template<>
  class array< ::gov::cca::ports::ParameterGetListener >: public 
    interface_array< array_traits< ::gov::cca::ports::ParameterGetListener > > {
  public:
    typedef interface_array< array_traits< 
      ::gov::cca::ports::ParameterGetListener > > Base;
    typedef array_traits< ::gov::cca::ports::ParameterGetListener 
      >::cxx_array_t          cxx_array_t;
    typedef array_traits< ::gov::cca::ports::ParameterGetListener >::cxx_item_t 
      cxx_item_t;
    typedef array_traits< ::gov::cca::ports::ParameterGetListener 
      >::ior_array_t          ior_array_t;
    typedef array_traits< ::gov::cca::ports::ParameterGetListener 
      >::ior_array_internal_t ior_array_internal_t;
    typedef array_traits< ::gov::cca::ports::ParameterGetListener >::ior_item_t 
      ior_item_t;

    /**
     * conversion from ior to C++ class
     * (constructor/casting operator)
     */
    array( struct gov_cca_ports_ParameterGetListener__array* src = 0) : 
      Base(src) {}

    /**
     * copy constructor
     */
    array( const array< ::gov::cca::ports::ParameterGetListener >&src) : 
      Base(src) {}

    /**
     * assignment
     */
    array< ::gov::cca::ports::ParameterGetListener >&
    operator =( const array< ::gov::cca::ports::ParameterGetListener >&rhs ) { 
      if (d_array != rhs._get_baseior()) {
        if (d_array) deleteRef();
        d_array = const_cast<sidl__array *>(rhs._get_baseior());
        if (d_array) addRef();
      }
      return *this;
    }

  };
}

#endif
