/*
 * File:          gov_cca_ports_ParameterPort_IOR.h
 * Symbol:        gov.cca.ports.ParameterPort-v0.6.3
 * Symbol Type:   interface
 * Babel Version: 0.10.2
 * Description:   Intermediate Object Representation for gov.cca.ports.ParameterPort
 * 
 * WARNING: Automatically generated; changes will be lost
 * 
 * babel-version = 0.10.2
 */

#ifndef included_gov_cca_ports_ParameterPort_IOR_h
#define included_gov_cca_ports_ParameterPort_IOR_h

#ifndef included_sidl_header_h
#include "sidl_header.h"
#endif
#ifndef included_sidl_io_Serializer_h
#include "sidl_io_Serializer.h"
#endif
#ifndef included_sidl_io_Deserializer_h
#include "sidl_io_Deserializer.h"
#endif
#ifdef __cplusplus
extern "C" {
#endif

/*
 * Symbol "gov.cca.ports.ParameterPort" (version 0.6.3)
 * 
 * This type of interface is exported for manipulation by other
 * components or by a user-interface (UI) (text or graphic).
 * By using the port ParameterFactory the component
 * writer never actually has to implement this port directly.
 * The recommended instance name for this port type is "CONFIG",
 * if a component provides only one such port. 
 * Component assembly or user interface rendering agents might 
 * assume this name. However, clever agents will act based on
 * port type rather than port instance name.
 * 
 * Data types represented: Anything representable in a TypeMap.
 * The following auxiliary information is managed for the benefit
 * of component end-user, UI, and other agents. 
 * Per map:
 * - title -- a name suitable to a top level window frame.
 * - group names -- data items are put in subsets (groups)
 *                  as, for example, in tabbed dialogs.
 * - list of all published parameter keys, those defined
 *   with the add functions of ParameterPortFactory. 
 * Per group name:
 * - group title -- ui-appropriate subset title, typically a tab heading.
 * - group keys -- list of data item keys in a named group.
 * Per data item key:
 * - default value 
 * - current value -- queryable directly from TypeMap by key name.
 * - help string -- potentially long-winded explanation of parameter use.
 * - prompt string -- shorter than help string and usually shown
 *                    in UI somehow while soliciting input.
 * - numeric bounds or value choice list. Where data type is
 *   an array type, the choice or bound restrictions are applied
 *   element-wise.
 * 
 * 
 * Special notes:
 * - The rendering of array-valued parameters in UI's poses a variety
 * of thorny problems in human-computer interaction. Use of
 * array parameters should be considered carefully. Not all UI
 * agents may be able to render array-valued parameters.
 * - Keys in the TypeMap with names starting with "gcpPPF." are
 *   reserved for private use by the 
 *   ParameterPortFactory implementation.
 */

struct gov_cca_ports_ParameterPort__array;
struct gov_cca_ports_ParameterPort__object;

/*
 * Forward references for external classes and interfaces.
 */

struct gov_cca_CCAException__array;
struct gov_cca_CCAException__object;
struct gov_cca_TypeMap__array;
struct gov_cca_TypeMap__object;
struct sidl_BaseException__array;
struct sidl_BaseException__object;
struct sidl_BaseInterface__array;
struct sidl_BaseInterface__object;
struct sidl_ClassInfo__array;
struct sidl_ClassInfo__object;

/*
 * Declare the method entry point vector.
 */

struct gov_cca_ports_ParameterPort__epv {
  /* Implicit builtin methods */
  void* (*f__cast)(
    /* in */ void* self,
    /* in */ const char* name);
  void (*f__delete)(
    /* in */ void* self);
  void (*f__exec)(
    /* in */ void* self,
    /* in */ const char* methodName,
    /* in */ struct sidl_io_Deserializer__object* inArgs,
    /* in */ struct sidl_io_Serializer__object* outArgs);
  /* Methods introduced in sidl.BaseInterface-v0.9.1 */
  void (*f_addRef)(
    /* in */ void* self);
  void (*f_deleteRef)(
    /* in */ void* self);
  sidl_bool (*f_isSame)(
    /* in */ void* self,
    /* in */ struct sidl_BaseInterface__object* iobj);
  struct sidl_BaseInterface__object* (*f_queryInt)(
    /* in */ void* self,
    /* in */ const char* name);
  sidl_bool (*f_isType)(
    /* in */ void* self,
    /* in */ const char* name);
  struct sidl_ClassInfo__object* (*f_getClassInfo)(
    /* in */ void* self);
  /* Methods introduced in gov.cca.Port-v0.6.3 */
  /* Methods introduced in gov.cca.ports.BasicParameterPort-v0.6.3 */
  struct gov_cca_TypeMap__object* (*f_readConfigurationMap)(
    /* in */ void* self,
    /* out */ struct sidl_BaseInterface__object* *_ex);
  void (*f_writeConfigurationMap)(
    /* in */ void* self,
    /* in */ struct gov_cca_TypeMap__object* map);
  struct sidl_string__array* (*f_readConfigurationKeys)(
    /* in */ void* self);
  /* Methods introduced in gov.cca.ports.ParameterPort-v0.6.3 */
  char* (*f_readTitle)(
    /* in */ void* self);
  struct sidl_string__array* (*f_readGroupNames)(
    /* in */ void* self);
  char* (*f_readGroupTitle)(
    /* in */ void* self,
    /* in */ const char* groupName,
    /* out */ struct sidl_BaseInterface__object* *_ex);
  struct sidl_string__array* (*f_readGroupKeys)(
    /* in */ void* self,
    /* in */ const char* groupName,
    /* out */ struct sidl_BaseInterface__object* *_ex);
  char* (*f_readHelp)(
    /* in */ void* self,
    /* in */ const char* key,
    /* out */ struct sidl_BaseInterface__object* *_ex);
  char* (*f_readPrompt)(
    /* in */ void* self,
    /* in */ const char* key,
    /* out */ struct sidl_BaseInterface__object* *_ex);
  sidl_bool (*f_hasBounds)(
    /* in */ void* self,
    /* in */ const char* key,
    /* out */ struct sidl_BaseInterface__object* *_ex);
  sidl_bool (*f_hasChoices)(
    /* in */ void* self,
    /* in */ const char* key,
    /* out */ struct sidl_BaseInterface__object* *_ex);
  sidl_bool (*f_readDefaultBoolean)(
    /* in */ void* self,
    /* in */ const char* key,
    /* out */ struct sidl_BaseInterface__object* *_ex);
  char* (*f_readDefaultString)(
    /* in */ void* self,
    /* in */ const char* key,
    /* out */ struct sidl_BaseInterface__object* *_ex);
  int32_t (*f_readDefaultInt)(
    /* in */ void* self,
    /* in */ const char* key,
    /* out */ struct sidl_BaseInterface__object* *_ex);
  int64_t (*f_readDefaultLong)(
    /* in */ void* self,
    /* in */ const char* key,
    /* out */ struct sidl_BaseInterface__object* *_ex);
  float (*f_readDefaultFloat)(
    /* in */ void* self,
    /* in */ const char* key,
    /* out */ struct sidl_BaseInterface__object* *_ex);
  double (*f_readDefaultDouble)(
    /* in */ void* self,
    /* in */ const char* key,
    /* out */ struct sidl_BaseInterface__object* *_ex);
  struct sidl_fcomplex (*f_readDefaultFcomplex)(
    /* in */ void* self,
    /* in */ const char* key,
    /* out */ struct sidl_BaseInterface__object* *_ex);
  struct sidl_dcomplex (*f_readDefaultDcomplex)(
    /* in */ void* self,
    /* in */ const char* key,
    /* out */ struct sidl_BaseInterface__object* *_ex);
  struct sidl_string__array* (*f_readDefaultStringArray)(
    /* in */ void* self,
    /* in */ const char* key,
    /* out */ struct sidl_BaseInterface__object* *_ex);
  struct sidl_bool__array* (*f_readDefaultBooleanArray)(
    /* in */ void* self,
    /* in */ const char* key,
    /* out */ struct sidl_BaseInterface__object* *_ex);
  struct sidl_int__array* (*f_readDefaultIntArray)(
    /* in */ void* self,
    /* in */ const char* key,
    /* out */ struct sidl_BaseInterface__object* *_ex);
  struct sidl_long__array* (*f_readDefaultLongArray)(
    /* in */ void* self,
    /* in */ const char* key,
    /* out */ struct sidl_BaseInterface__object* *_ex);
  struct sidl_float__array* (*f_readDefaultFloatArray)(
    /* in */ void* self,
    /* in */ const char* key,
    /* out */ struct sidl_BaseInterface__object* *_ex);
  struct sidl_double__array* (*f_readDefaultDoubleArray)(
    /* in */ void* self,
    /* in */ const char* key,
    /* out */ struct sidl_BaseInterface__object* *_ex);
  struct sidl_fcomplex__array* (*f_readDefaultFcomplexArray)(
    /* in */ void* self,
    /* in */ const char* key,
    /* out */ struct sidl_BaseInterface__object* *_ex);
  struct sidl_dcomplex__array* (*f_readDefaultDcomplexArray)(
    /* in */ void* self,
    /* in */ const char* key,
    /* out */ struct sidl_BaseInterface__object* *_ex);
  void (*f_readBoundsInt)(
    /* in */ void* self,
    /* in */ const char* key,
    /* out */ int32_t* low,
    /* out */ int32_t* high,
    /* out */ struct sidl_BaseInterface__object* *_ex);
  void (*f_readBoundsLong)(
    /* in */ void* self,
    /* in */ const char* key,
    /* out */ int64_t* low,
    /* out */ int64_t* high,
    /* out */ struct sidl_BaseInterface__object* *_ex);
  void (*f_readBoundsFloat)(
    /* in */ void* self,
    /* in */ const char* key,
    /* out */ float* low,
    /* out */ float* high,
    /* out */ struct sidl_BaseInterface__object* *_ex);
  void (*f_readBoundsDouble)(
    /* in */ void* self,
    /* in */ const char* key,
    /* out */ double* low,
    /* out */ double* high,
    /* out */ struct sidl_BaseInterface__object* *_ex);
  struct sidl_string__array* (*f_readChoicesString)(
    /* in */ void* self,
    /* in */ const char* key,
    /* out */ struct sidl_BaseInterface__object* *_ex);
  struct sidl_int__array* (*f_readChoicesInt)(
    /* in */ void* self,
    /* in */ const char* key,
    /* out */ struct sidl_BaseInterface__object* *_ex);
  struct sidl_long__array* (*f_readChoicesLong)(
    /* in */ void* self,
    /* in */ const char* key,
    /* out */ struct sidl_BaseInterface__object* *_ex);
  struct sidl_float__array* (*f_readChoicesFloat)(
    /* in */ void* self,
    /* in */ const char* key,
    /* out */ struct sidl_BaseInterface__object* *_ex);
  struct sidl_double__array* (*f_readChoicesDouble)(
    /* in */ void* self,
    /* in */ const char* key,
    /* out */ struct sidl_BaseInterface__object* *_ex);
  struct sidl_fcomplex__array* (*f_readChoicesFcomplex)(
    /* in */ void* self,
    /* in */ const char* key,
    /* out */ struct sidl_BaseInterface__object* *_ex);
  struct sidl_dcomplex__array* (*f_readChoicesDcomplex)(
    /* in */ void* self,
    /* in */ const char* key,
    /* out */ struct sidl_BaseInterface__object* *_ex);
};

/*
 * Define the interface object structure.
 */

struct gov_cca_ports_ParameterPort__object {
  struct gov_cca_ports_ParameterPort__epv* d_epv;
  void*                                    d_object;
};

#ifdef __cplusplus
}
#endif
#endif
