/*
 * File:          sort_SortingAlgorithm_Impl.c
 * Symbol:        sort.SortingAlgorithm-v0.1
 * Symbol Type:   class
 * Babel Version: 0.10.2
 * Description:   Server-side implementation for sort.SortingAlgorithm
 * 
 * WARNING: Automatically generated; only changes within splicers preserved
 * 
 * babel-version = 0.10.2
 */

/*
 * DEVELOPERS ARE EXPECTED TO PROVIDE IMPLEMENTATIONS
 * FOR THE FOLLOWING METHODS BETWEEN SPLICER PAIRS.
 */

/*
 * Symbol "sort.SortingAlgorithm" (version 0.1)
 * 
 * An abstract sorting algorithm.
 */

#include "sort_SortingAlgorithm_Impl.h"

#line 26 "../../../../babel/regression/sort/libC/sort_SortingAlgorithm_Impl.c"
/* DO-NOT-DELETE splicer.begin(sort.SortingAlgorithm._includes) */
#include <stdlib.h>
#include "sort_SimpleCounter.h"
/* DO-NOT-DELETE splicer.end(sort.SortingAlgorithm._includes) */
#line 31 "sort_SortingAlgorithm_Impl.c"

/*
 * Static class initializer called exactly once before any user-defined method is dispatched
 */

#undef __FUNC__
#define __FUNC__ "impl_sort_SortingAlgorithm__load"

void
impl_sort_SortingAlgorithm__load(
  void)
{
#line 42 "../../../../babel/regression/sort/libC/sort_SortingAlgorithm_Impl.c"
  /* DO-NOT-DELETE splicer.begin(sort.SortingAlgorithm._load) */
  /* Insert the implementation of the static class initializer method here... */
  /* DO-NOT-DELETE splicer.end(sort.SortingAlgorithm._load) */
#line 48 "sort_SortingAlgorithm_Impl.c"
}
/*
 * Class constructor called when the class is created.
 */

#undef __FUNC__
#define __FUNC__ "impl_sort_SortingAlgorithm__ctor"

void
impl_sort_SortingAlgorithm__ctor(
  /* in */ sort_SortingAlgorithm self)
{
#line 57 "../../../../babel/regression/sort/libC/sort_SortingAlgorithm_Impl.c"
  /* DO-NOT-DELETE splicer.begin(sort.SortingAlgorithm._ctor) */
  struct sort_SortingAlgorithm__data *dptr = 
    malloc(sizeof(struct sort_SortingAlgorithm__data ));
  if (dptr) {
    dptr->d_swp = sort_Counter__cast(sort_SimpleCounter__create());
    dptr->d_cmp = sort_Counter__cast(sort_SimpleCounter__create());
  }
  sort_SortingAlgorithm__set_data(self, dptr);
  /* DO-NOT-DELETE splicer.end(sort.SortingAlgorithm._ctor) */
#line 71 "sort_SortingAlgorithm_Impl.c"
}

/*
 * Class destructor called when the class is deleted.
 */

#undef __FUNC__
#define __FUNC__ "impl_sort_SortingAlgorithm__dtor"

void
impl_sort_SortingAlgorithm__dtor(
  /* in */ sort_SortingAlgorithm self)
{
#line 79 "../../../../babel/regression/sort/libC/sort_SortingAlgorithm_Impl.c"
  /* DO-NOT-DELETE splicer.begin(sort.SortingAlgorithm._dtor) */
  struct sort_SortingAlgorithm__data *dptr = 
    sort_SortingAlgorithm__get_data(self);
  if (dptr) {
    sort_Counter_deleteRef(dptr->d_swp);
    dptr->d_swp = NULL;
    sort_Counter_deleteRef(dptr->d_cmp);
    dptr->d_cmp = NULL;
    free((void *)dptr);
  }
  /* DO-NOT-DELETE splicer.end(sort.SortingAlgorithm._dtor) */
#line 97 "sort_SortingAlgorithm_Impl.c"
}

/*
 * Return the comparison counter.
 */

#undef __FUNC__
#define __FUNC__ "impl_sort_SortingAlgorithm_getCompareCounter"

sort_Counter
impl_sort_SortingAlgorithm_getCompareCounter(
  /* in */ sort_SortingAlgorithm self)
{
#line 103 "../../../../babel/regression/sort/libC/sort_SortingAlgorithm_Impl.c"
  /* DO-NOT-DELETE splicer.begin(sort.SortingAlgorithm.getCompareCounter) */
  struct sort_SortingAlgorithm__data *dptr = 
    sort_SortingAlgorithm__get_data(self);
  sort_Counter result = NULL;
  if (dptr) {
    sort_Counter_addRef(dptr->d_cmp);
    result = dptr->d_cmp;
  }
  return result;
  /* DO-NOT-DELETE splicer.end(sort.SortingAlgorithm.getCompareCounter) */
#line 122 "sort_SortingAlgorithm_Impl.c"
}

/*
 * Return the swap counter.
 */

#undef __FUNC__
#define __FUNC__ "impl_sort_SortingAlgorithm_getSwapCounter"

sort_Counter
impl_sort_SortingAlgorithm_getSwapCounter(
  /* in */ sort_SortingAlgorithm self)
{
#line 126 "../../../../babel/regression/sort/libC/sort_SortingAlgorithm_Impl.c"
  /* DO-NOT-DELETE splicer.begin(sort.SortingAlgorithm.getSwapCounter) */
  struct sort_SortingAlgorithm__data *dptr = 
    sort_SortingAlgorithm__get_data(self);
  sort_Counter result = NULL;
  if (dptr) {
    sort_Counter_addRef(dptr->d_swp);
    result = dptr->d_swp;
  }
  return result;
  /* DO-NOT-DELETE splicer.end(sort.SortingAlgorithm.getSwapCounter) */
#line 147 "sort_SortingAlgorithm_Impl.c"
}

/*
 * Reset the comparison and swap counter.
 */

#undef __FUNC__
#define __FUNC__ "impl_sort_SortingAlgorithm_reset"

void
impl_sort_SortingAlgorithm_reset(
  /* in */ sort_SortingAlgorithm self)
{
#line 149 "../../../../babel/regression/sort/libC/sort_SortingAlgorithm_Impl.c"
  /* DO-NOT-DELETE splicer.begin(sort.SortingAlgorithm.reset) */
  struct sort_SortingAlgorithm__data *dptr = 
    sort_SortingAlgorithm__get_data(self);
  if (dptr) {
    sort_Counter_reset(dptr->d_swp);
    sort_Counter_reset(dptr->d_cmp);
  }
  /* DO-NOT-DELETE splicer.end(sort.SortingAlgorithm.reset) */
#line 170 "sort_SortingAlgorithm_Impl.c"
}
