/*
 * File:          sort_HeapSort_jniStub.c
 * Symbol:        sort.HeapSort-v0.1
 * Symbol Type:   class
 * Babel Version: 0.10.2
 * Description:   Client-side JNI glue code for sort.HeapSort
 * 
 * WARNING: Automatically generated; changes will be lost
 * 
 * babel-version = 0.10.2
 */

#include "sidl_Java.h"
#include "sidl_Loader.h"
#include "sidl_String.h"
#include "sort_HeapSort_IOR.h"
#include "babel_config.h"

/*
 * Convert between jlong and void* pointers.
 */

#if (SIZEOF_VOID_P == 8)
#define JLONG_TO_POINTER(x) ((void*)(x))
#define POINTER_TO_JLONG(x) ((jlong)(x))
#else
#define JLONG_TO_POINTER(x) ((void*)(int32_t)(x))
#define POINTER_TO_JLONG(x) ((jlong)(int32_t)(x))
#endif

#ifndef NULL
#define NULL 0
#endif

/*
 * Function to extract IOR reference from the Java object.
 */

static struct sort_HeapSort__object* _get_ior(
  JNIEnv* env,
  jobject obj)
{
  void* ptr = NULL;
  static jmethodID mid = (jmethodID) NULL;

  if (mid == (jmethodID) NULL) {
    jclass cls = (*env)->GetObjectClass(env, obj);
    mid = (*env)->GetMethodID(env, cls, "_get_ior", "()J");
    (*env)->DeleteLocalRef(env, cls);
  }

  ptr = JLONG_TO_POINTER((*env)->CallLongMethod(env, obj, mid));
  return (struct sort_HeapSort__object*) ptr;
}

/*
 * External reference to IOR methods.
 */

static const struct sort_HeapSort__external* s_external = NULL;

/*
 * Create object instance and return reference.
 */

static jlong jni__create_ior(
  JNIEnv* env,
  jclass  cls)
{
  (void) env;
  (void) cls;
  return POINTER_TO_JLONG((*s_external->createObject)());
}

/*
 * Sort elements using Heap Sort.
 */

static void
jni_sort(
  JNIEnv* env,
  jobject obj,
  jobject _arg_elems,
  jobject _arg_comp)
{
  /*
   * Declare return and temporary variables.
   */

  struct sort_HeapSort__object* _ior = NULL;
  struct sort_Container__object* _tmp_elems = (struct sort_Container__object*) 
    NULL;
  struct sort_Comparator__object* _tmp_comp = (struct sort_Comparator__object*) 
    NULL;

  /*
   * Preprocess Java types and convert into IOR.
   */

  _ior = _get_ior(env, obj);
  _tmp_elems = (struct sort_Container__object*) sidl_Java_J2I_ifc(env,
    _arg_elems, "sort.Container");
  _tmp_comp = (struct sort_Comparator__object*) sidl_Java_J2I_ifc(env,
    _arg_comp, "sort.Comparator");

  /*
   * Call the IOR method through the EPV.
   */

  (*(_ior->d_epv->f_sort))(
    _ior,
    _tmp_elems,
    _tmp_comp);

  /*
   * Postprocess OUT, INOUT, returns, and exceptions.
   */

}

/*
 * Return heap sort.
 */

static jstring
jni_getName(
  JNIEnv* env,
  jobject obj)
{
  /*
   * Declare return and temporary variables.
   */

  struct sort_HeapSort__object* _ior = NULL;
  char* _ior_res = (char*) NULL;
  jstring _res = (jstring) NULL;

  /*
   * Preprocess Java types and convert into IOR.
   */

  _ior = _get_ior(env, obj);

  /*
   * Call the IOR method through the EPV.
   */

  _ior_res = (*(_ior->d_epv->f_getName))(
    _ior);

  /*
   * Postprocess OUT, INOUT, returns, and exceptions.
   */

  _res = sidl_Java_I2J_string(env, _ior_res);
  sidl_String_free(_ior_res);

  return _res;
}

/*
 * Register JNI methods with the Java JVM.
 */

void sort_HeapSort__register(JNIEnv* env)
{
  JNINativeMethod methods[3];
  jclass cls;

#ifdef SIDL_STATIC_LIBRARY
  s_external = sort_HeapSort__externals();
#else
  sidl_DLL dll = sidl_DLL__create();
  const struct sort_HeapSort__external*(*dll_f)(void);
  /* check global namespace for symbol first */
  if (dll && sidl_DLL_loadLibrary(dll, "main:", TRUE, FALSE)) {
    dll_f =
      (const struct sort_HeapSort__external*(*)(void)) sidl_DLL_lookupSymbol(
        dll, "sort_HeapSort__externals");
    s_external = (dll_f ? (*dll_f)() : NULL);
  }
  if (dll) sidl_DLL_deleteRef(dll);
  if (!s_external) {
    dll = sidl_Loader_findLibrary("sort.HeapSort",
      "ior/impl", sidl_Scope_SCLSCOPE,
      sidl_Resolve_SCLRESOLVE);
    if (dll) {
      dll_f =
        (const struct sort_HeapSort__external*(*)(void)) sidl_DLL_lookupSymbol(
          dll, "sort_HeapSort__externals");
      s_external = (dll_f ? (*dll_f)() : NULL);
      sidl_DLL_deleteRef(dll);
    }
  }
  if (!s_external) {
    jclass e = (*env)->FindClass(env, "java/lang/UnsatisfiedLinkError");
    if (e != NULL) {
      (*env)->ThrowNew(env, e, "Could not find implementation for sidl class sort.HeapSort");
      (*env)->DeleteLocalRef(env, e);
    }
  }
#endif

  methods[0].name      = "_create_ior";
  methods[0].signature = "()J";
  methods[0].fnPtr     = (void *)jni__create_ior;
  methods[1].name      = "sort";
  methods[1].signature = "(Lsort/Container;Lsort/Comparator;)V";
  methods[1].fnPtr     = (void *)jni_sort;
  methods[2].name      = "getName";
  methods[2].signature = "()Ljava/lang/String;";
  methods[2].fnPtr     = (void *)jni_getName;


  cls = (*env)->FindClass(env, "sort/HeapSort");
  if (cls) {
    (*env)->RegisterNatives(env, cls, methods, 3);
    (*env)->DeleteLocalRef(env, cls);
  }
}
