/*
 * File:          sort_SortingAlgorithm_jniStub.c
 * Symbol:        sort.SortingAlgorithm-v0.1
 * Symbol Type:   class
 * Babel Version: 0.10.2
 * Description:   Client-side JNI glue code for sort.SortingAlgorithm
 * 
 * WARNING: Automatically generated; changes will be lost
 * 
 * babel-version = 0.10.2
 */

#include "sidl_Java.h"
#include "sidl_Loader.h"
#include "sidl_String.h"
#include "sort_SortingAlgorithm_IOR.h"
#include "babel_config.h"

/*
 * Convert between jlong and void* pointers.
 */

#if (SIZEOF_VOID_P == 8)
#define JLONG_TO_POINTER(x) ((void*)(x))
#define POINTER_TO_JLONG(x) ((jlong)(x))
#else
#define JLONG_TO_POINTER(x) ((void*)(int32_t)(x))
#define POINTER_TO_JLONG(x) ((jlong)(int32_t)(x))
#endif

#ifndef NULL
#define NULL 0
#endif

/*
 * Function to extract IOR reference from the Java object.
 */

static struct sort_SortingAlgorithm__object* _get_ior(
  JNIEnv* env,
  jobject obj)
{
  void* ptr = NULL;
  static jmethodID mid = (jmethodID) NULL;

  if (mid == (jmethodID) NULL) {
    jclass cls = (*env)->GetObjectClass(env, obj);
    mid = (*env)->GetMethodID(env, cls, "_get_ior", "()J");
    (*env)->DeleteLocalRef(env, cls);
  }

  ptr = JLONG_TO_POINTER((*env)->CallLongMethod(env, obj, mid));
  return (struct sort_SortingAlgorithm__object*) ptr;
}

/*
 * Return the comparison counter.
 */

static jobject
jni_getCompareCounter(
  JNIEnv* env,
  jobject obj)
{
  /*
   * Declare return and temporary variables.
   */

  struct sort_SortingAlgorithm__object* _ior = NULL;
  struct sort_Counter__object* _ior_res = (struct sort_Counter__object*) NULL;
  jobject _res = (jobject) NULL;

  /*
   * Preprocess Java types and convert into IOR.
   */

  _ior = _get_ior(env, obj);

  /*
   * Call the IOR method through the EPV.
   */

  _ior_res = (*(_ior->d_epv->f_getCompareCounter))(
    _ior);

  /*
   * Postprocess OUT, INOUT, returns, and exceptions.
   */

  _res = sidl_Java_I2J_ifc(env, _ior_res, "sort.Counter");

  return _res;
}

/*
 * Return the swap counter.
 */

static jobject
jni_getSwapCounter(
  JNIEnv* env,
  jobject obj)
{
  /*
   * Declare return and temporary variables.
   */

  struct sort_SortingAlgorithm__object* _ior = NULL;
  struct sort_Counter__object* _ior_res = (struct sort_Counter__object*) NULL;
  jobject _res = (jobject) NULL;

  /*
   * Preprocess Java types and convert into IOR.
   */

  _ior = _get_ior(env, obj);

  /*
   * Call the IOR method through the EPV.
   */

  _ior_res = (*(_ior->d_epv->f_getSwapCounter))(
    _ior);

  /*
   * Postprocess OUT, INOUT, returns, and exceptions.
   */

  _res = sidl_Java_I2J_ifc(env, _ior_res, "sort.Counter");

  return _res;
}

/*
 * Reset the comparison and swap counter.
 */

static void
jni_reset(
  JNIEnv* env,
  jobject obj)
{
  /*
   * Declare return and temporary variables.
   */

  struct sort_SortingAlgorithm__object* _ior = NULL;

  /*
   * Preprocess Java types and convert into IOR.
   */

  _ior = _get_ior(env, obj);

  /*
   * Call the IOR method through the EPV.
   */

  (*(_ior->d_epv->f_reset))(
    _ior);

  /*
   * Postprocess OUT, INOUT, returns, and exceptions.
   */

}

/*
 * Sort elems according to the ordering implied by comp.
 */

static void
jni_sort(
  JNIEnv* env,
  jobject obj,
  jobject _arg_elems,
  jobject _arg_comp)
{
  /*
   * Declare return and temporary variables.
   */

  struct sort_SortingAlgorithm__object* _ior = NULL;
  struct sort_Container__object* _tmp_elems = (struct sort_Container__object*) 
    NULL;
  struct sort_Comparator__object* _tmp_comp = (struct sort_Comparator__object*) 
    NULL;

  /*
   * Preprocess Java types and convert into IOR.
   */

  _ior = _get_ior(env, obj);
  _tmp_elems = (struct sort_Container__object*) sidl_Java_J2I_ifc(env,
    _arg_elems, "sort.Container");
  _tmp_comp = (struct sort_Comparator__object*) sidl_Java_J2I_ifc(env,
    _arg_comp, "sort.Comparator");

  /*
   * Call the IOR method through the EPV.
   */

  (*(_ior->d_epv->f_sort))(
    _ior,
    _tmp_elems,
    _tmp_comp);

  /*
   * Postprocess OUT, INOUT, returns, and exceptions.
   */

}

/*
 * Return the name of the sorting algorithm.
 */

static jstring
jni_getName(
  JNIEnv* env,
  jobject obj)
{
  /*
   * Declare return and temporary variables.
   */

  struct sort_SortingAlgorithm__object* _ior = NULL;
  char* _ior_res = (char*) NULL;
  jstring _res = (jstring) NULL;

  /*
   * Preprocess Java types and convert into IOR.
   */

  _ior = _get_ior(env, obj);

  /*
   * Call the IOR method through the EPV.
   */

  _ior_res = (*(_ior->d_epv->f_getName))(
    _ior);

  /*
   * Postprocess OUT, INOUT, returns, and exceptions.
   */

  _res = sidl_Java_I2J_string(env, _ior_res);
  sidl_String_free(_ior_res);

  return _res;
}

/*
 * Register JNI methods with the Java JVM.
 */

void sort_SortingAlgorithm__register(JNIEnv* env)
{
  JNINativeMethod methods[5];
  jclass cls;

  methods[0].name      = "getCompareCounter";
  methods[0].signature = "()Lsort/Counter;";
  methods[0].fnPtr     = (void *)jni_getCompareCounter;
  methods[1].name      = "getSwapCounter";
  methods[1].signature = "()Lsort/Counter;";
  methods[1].fnPtr     = (void *)jni_getSwapCounter;
  methods[2].name      = "reset";
  methods[2].signature = "()V";
  methods[2].fnPtr     = (void *)jni_reset;
  methods[3].name      = "sort";
  methods[3].signature = "(Lsort/Container;Lsort/Comparator;)V";
  methods[3].fnPtr     = (void *)jni_sort;
  methods[4].name      = "getName";
  methods[4].signature = "()Ljava/lang/String;";
  methods[4].fnPtr     = (void *)jni_getName;


  cls = (*env)->FindClass(env, "sort/SortingAlgorithm");
  if (cls) {
    (*env)->RegisterNatives(env, cls, methods, 5);
    (*env)->DeleteLocalRef(env, cls);
  }
}
